/*
 * MIPS floating point support
 * Copyright (C) 1994-2000 Algorithmics Ltd.  All rights reserved.
 * http://www.algor.co.uk
 *
 * ########################################################################
 *
 *  This program is free software; you can distribute it and/or modify it
 *  under the terms of the GNU General Public License (Version 2) as
 *  published by the Free Software Foundation.
 *
 *  This program is distributed in the hope it will be useful, but WITHOUT
 *  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 *  for more details.
 *
 *  You should have received a copy of the GNU General Public License along
 *  with this program; if not, write to the Free Software Foundation, Inc.,
 *  59 Temple Place - Suite 330, Boston MA 02111-1307, USA.
 *
 * ########################################################################
 */

/**************************************************************************
 *
 *  December 14, 1999
 *  Added preprocessor hacks to map to Linux kernel diagnostics. 
 *
 *  Kevin D. Kissell, kevink@acm.org
 *  Copyright (C) 1999 MIPS Technologies, Inc.  All rights reserved.
 *
 *************************************************************************/

#if !#system(sde) && !defined(__KERNEL__)
#include <stdio.h>
#endif

#ifdef __KERNEL__
#define _mon_printf printk
#endif

#include "ieee754.h"

/*
 * Very naff exception handler (you can plug in your own and
 * override this).
 */

static const char * const rtnames[] = {
	"sp", "dp", "xp", "si", "di"
};

void ieee754_xcpt(struct ieee754xctx *xcp)
{
#if #system(sde) || defined(__KERNEL__)
    _mon_printf ("floating point exception in \"%s\", type=%s\n", 
		 xcp->op, rtnames[xcp->rt]);
#else
    fprintf (stderr, "floating point exception in \"%s\", type=%s\n", 
	     xcp->op, rtnames[xcp->rt]);
#endif
}
