/*
 * $Id: kbd_uart.c,v 1.2 2000/05/17 13:05:32 nop Exp $
 *
 * UARTB "keyboard" handler.  Based on kbd.c which is
 *
 * Copyright (C) 1999 Harald Koerfgen
 * 
 * This file is subject to the terms and conditions of the GNU General Public
 * License.  See the file "COPYING" in the main directory of this archive
 * for more details.
 *
 */

/*  This code has not been tested against real hardware.  */

#include <linux/sched.h>
#include <linux/tty.h>
#include <linux/mm.h>
#include <linux/kbd_kern.h>
#include <linux/errno.h>
#include <linux/init.h>
#include <linux/kbd_ll.h>
#include <asm/keyboard.h>
#include <asm/r39xx.h>
#include <asm/bootinfo.h>

void kbd_scan(void);
static void kbd_timer_handler(unsigned long);

static struct timer_list kbd_timer = {
    NULL, NULL, 0, 0L, kbd_timer_handler
};

static void kbd_timer_handler(unsigned long dev_addr)
{
      kbd_scan();
      kbd_timer.expires = jiffies+HZ/20;
      kbd_timer.data = 0;
      kbd_timer.next = kbd_timer.prev = NULL;
      add_timer(&kbd_timer);
}

void kbd_leds(unsigned char leds)
{
	return;
}

int kbd_setkeycode(unsigned int scancode, unsigned int keycode)
{
	return -EINVAL;
}

int kbd_getkeycode(unsigned int scancode)
{
	return -EINVAL;
}

int kbd_translate(unsigned char scancode, unsigned char *keycode,
	char raw_mode)
{
	*keycode = scancode;
	return 1;
}

char kbd_unexpected_up(unsigned char keycode)
{
        /* We end up with a zillion of these because we're faking
           keypress to wake up the driver */
	/* printk(__FUNCTION__": unexpected up, keycode 0x%x\n", keycode); */
	return 0x80;
}

void kbd_scan(void)
{
        unsigned int readin;

        if (UartB_Ctrl1 & UART_RX_HOLD_FULL) {
                readin = UartB_Data;
                readin &= 0xff;
                /* printk("got char %d  ", readin); */
                /* Horrible hack: wake up the driver by claiming we have a key pressed. */
                handle_scancode(0,0); 
                put_queue(readin);
        }
}

void __init kbd_init_hw(void)
{
        printk("UARTB Keyboard driver version 0.1\n");

        /* Setup master clock for UART */
        ClockControl &= ~CLK_SIBMCLKDIV_MASK;
        ClockControl |= CLK_SIBMCLKDIR | CLK_ENSIBMCLK |
                ((2 << CLK_SIBMCLKDIV_SHIFT) & CLK_SIBMCLKDIV_MASK) |
                CLK_CSERSEL;

        /* Configure UARTB clock */
        ClockControl |= ((3 << CLK_CSERDIV_SHIFT) & CLK_CSERDIV_MASK) |
		CLK_ENCSERCLK | CLK_EN_UART_B;

        UartB_Ctrl2 = SER_BAUD_9600;
        UartB_Ctrl1 = UART_ENABLE;

        kbd_timer_handler(0);
}
