/*
 * cmdline.c: read the command line passed to us by the bootloader.
 *
 * Copyright (C) Harald Koerfgen
 *
 * $Id: cmdline.c,v 1.4 2000/05/03 02:05:59 nop Exp $
 */
#include <linux/init.h>
#include <linux/kernel.h>
#include <linux/config.h>
#include <linux/string.h>

#include <asm/bootinfo.h>

#ifdef CONFIG_VTECH_HELIO
#define PROM_DEBUG
#ifdef CONFIG_BLK_DEV_ROM
extern unsigned char* romdisk; 
#define ROMDISK_START (*((int *)0x80003000))
#endif
#endif

#ifdef PROM_DEBUG
extern int prom_printf(const char *fmt, ...);
#endif

char arcs_cmdline[CL_SIZE];

void __init prom_init_cmdline(int argc, char **argv)
{
#ifndef CONFIG_VTECH_HELIO
	int i;

	/*
	 * collect args and prepare cmd_line
	 */
	for (i = 1; i < argc; i++) {
		strcat(arcs_cmdline, argv[i]);
		if (i < (argc - 1))
			strcat(arcs_cmdline, " ");
	}

#else /* CONFIG_VTECH_HELIO */
	/* The embryonic Helio boot loader doesn't support command lines yet. */
#ifdef CONFIG_BLK_DEV_ROM
	strcat(arcs_cmdline, "root=/dev/rom");
	romdisk = (char *)ROMDISK_START;
#else
	strcat(arcs_cmdline, "root=/dev/ram");
#endif
#endif

#ifdef PROM_DEBUG
	prom_printf("arcs_cmdline: %s\n", &(arcs_cmdline[0]));
#endif

}
