/*
 * linux/arch/mips/vr41xx/gpiolcd.c
 *
 * Platform support for the machine which LCD control by GPIO.
 *
 * Copyright (C) 2000 SATO Kazumi
 *
 * This file is subject to the terms and conditions of the GNU General Public
 * License.  See the file "COPYING" in the main directory of this archive
 * for more details.
 *
 */

#include <asm/io.h>
#include <asm/system.h>
#include <asm/vr41xx.h>

#ifdef CONFIG_NEC_MOBILEGEAR2_R300 
#define LCDON   VR41XX_GIUPIODL_GPIO10	/* GPIO[10] 0100 0000 0000 */
#define LCDON_PORT	VR41XX_GIUPIODL
#define LIGHTON VR41XX_GIUPODATL_GPIO45	/* GPIO[45] 10 0000 0000 0000 */
#define LIGHTON_PORT	VR41XX_GIUPODATL
#elif defined(CONFIG_NEC_MOBILEGEAR2_R310)
#define LCDON   VR41XX_GIUPIODL_GPIO10	/* GPIO[10] 0100 0000 0000 */
#define LCDON_PORT	VR41XX_GIUPIODL
#define LIGHTON VR41XX_GIUPODATL_GPIO45	/* GPIO[45] 10 0000 0000 0000 */
#define LIGHTON_PORT	VR41XX_GIUPODATL
#else
#error no LCD GPIO Infomation....
#endif

static int backlight, contrast, lcdpower;

int get_gpiolcd_backlight(void)
{
	return backlight;
}

int gpiolcd_backlight(int n)
{
	backlight = n;
	if(n == 0) {
		cli();
		*LIGHTON_PORT &= ~LIGHTON;
		sti();
		// Turn the backlight off.
	} else {
		cli();
		*LIGHTON_PORT |= LIGHTON;
		sti();
	}
	return 0;
}

int get_gpiolcd_contrast(void)
{
	return contrast;
}

int gpiolcd_contrast(int n)
{
	contrast = n;
	// Turn the lcd on and some contrast.
	return 0;
}

int get_gpiolcd_lcdpower(void)
{
	return lcdpower;
}

int gpiolcd_lcdpower(int n)
{
	lcdpower = n;
	if(n == 0) {
		cli();
		*LCDON_PORT &=  ~LCDON;
		sti();
	} else {
		cli();
		*LCDON_PORT |=  LCDON;
		sti();
	}
	return 0;
}

void gpiolcd_setup(void)
{
	gpiolcd_lcdpower(1);
	gpiolcd_contrast(6);
	gpiolcd_backlight(1);
}
